VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Cell"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'    Sudoku Solver
'    Copyright (C) 2006  S. I. Becker
'
'    This program is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program; if not, write to the Free Software
'    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
'
'    If you want to contact the authour, write to 44 Merrion Close,
'    Royal Tunbridge Wells, TN4 9JJ, England, or e-mail stewart@sibecker.co.uk

Option Explicit

Private m_Parent As Cells
Private m_Row As Long
Private m_Col As Long
Private m_Value As Long
Private m_PreKnown As Boolean
Private m_box As TextBox

Public Function CompareWith() As Cell()
    Dim cwList(1 To 20) As Cell
    Dim i As Long
    Dim j As Long
    Dim k As Long
    Dim RowLo As Long
    Dim RowHi As Long
    Dim ColLo As Long
    Dim ColHi As Long
       
    ' Same Row
    Select Case m_Col
    Case 1 To 3
        Set cwList(1) = m_Parent.Cell(Row, 4)
        Set cwList(2) = m_Parent.Cell(Row, 5)
        Set cwList(3) = m_Parent.Cell(Row, 6)
        Set cwList(4) = m_Parent.Cell(Row, 7)
        Set cwList(5) = m_Parent.Cell(Row, 8)
        Set cwList(6) = m_Parent.Cell(Row, 9)
        ColLo = 1
        ColHi = 3
    Case 4 To 6
        Set cwList(1) = m_Parent.Cell(Row, 1)
        Set cwList(2) = m_Parent.Cell(Row, 2)
        Set cwList(3) = m_Parent.Cell(Row, 3)
        Set cwList(4) = m_Parent.Cell(Row, 7)
        Set cwList(5) = m_Parent.Cell(Row, 8)
        Set cwList(6) = m_Parent.Cell(Row, 9)
        ColLo = 4
        ColHi = 6
    Case 7 To 9
        Set cwList(1) = m_Parent.Cell(Row, 1)
        Set cwList(2) = m_Parent.Cell(Row, 2)
        Set cwList(3) = m_Parent.Cell(Row, 3)
        Set cwList(4) = m_Parent.Cell(Row, 4)
        Set cwList(5) = m_Parent.Cell(Row, 5)
        Set cwList(6) = m_Parent.Cell(Row, 6)
        ColLo = 7
        ColHi = 9
    End Select
    
    ' Same Col
    Select Case m_Row
    Case 1 To 3
        Set cwList(7) = m_Parent.Cell(4, Col)
        Set cwList(8) = m_Parent.Cell(5, Col)
        Set cwList(9) = m_Parent.Cell(6, Col)
        Set cwList(10) = m_Parent.Cell(7, Col)
        Set cwList(11) = m_Parent.Cell(8, Col)
        Set cwList(12) = m_Parent.Cell(9, Col)
        RowLo = 1
        RowHi = 3
    Case 4 To 6
        Set cwList(7) = m_Parent.Cell(1, Col)
        Set cwList(8) = m_Parent.Cell(2, Col)
        Set cwList(9) = m_Parent.Cell(3, Col)
        Set cwList(10) = m_Parent.Cell(7, Col)
        Set cwList(11) = m_Parent.Cell(8, Col)
        Set cwList(12) = m_Parent.Cell(9, Col)
        RowLo = 4
        RowHi = 6
    Case 7 To 9
        Set cwList(7) = m_Parent.Cell(1, Col)
        Set cwList(8) = m_Parent.Cell(2, Col)
        Set cwList(9) = m_Parent.Cell(3, Col)
        Set cwList(10) = m_Parent.Cell(4, Col)
        Set cwList(11) = m_Parent.Cell(5, Col)
        Set cwList(12) = m_Parent.Cell(6, Col)
        RowLo = 7
        RowHi = 9
    End Select
        
    ' Same Box
    k = 13
    For i = RowLo To RowHi
        For j = ColLo To ColHi
            If (i <> m_Row) Or (j <> m_Col) Then
                Set cwList(k) = m_Parent.Cell(i, j)
                k = k + 1
            End If
        Next
    Next

    CompareWith = cwList
End Function

Public Function CanBe(Trial As Long)
    Dim i As Long
    Dim Compare As Cell
    Dim vCompare
    Dim CompWith() As Cell
    
    If PreKnown And (Trial <> Value) Then
        CanBe = False
        Exit Function
    End If
    
    CompWith = CompareWith
    For Each vCompare In CompWith
        Set Compare = vCompare
        If Compare.Value = Trial Then
            CanBe = False
            Exit Function
        End If
    Next
    
    CanBe = True
End Function

Public Property Get Value() As Long
    Value = m_Value
End Property

Public Property Let Value(newValue As Long)
    m_Value = newValue
End Property

Public Property Set Parent(newParent As Cells)
    Set m_Parent = newParent
End Property

Public Property Get PreKnown() As Boolean
    PreKnown = m_PreKnown
End Property

Public Property Let PreKnown(newValue As Boolean)
    m_PreKnown = newValue
End Property

Public Sub Solve(Solutions() As Solution, nSolutions As Long, bJust2 As Boolean)
    Dim k As Long
    Dim TheNextCell As Cell
    
    If bJust2 And (nSolutions > 1) Then Exit Sub
    
    Set TheNextCell = NextCell
    
    If m_PreKnown Then
        If CanBe(m_Value) Then
            If TheNextCell Is Nothing Then
                AddSolution Solutions, nSolutions
            Else
                TheNextCell.Solve Solutions, nSolutions, bJust2
            End If
        End If
    Else
        For k = 1 To 9
            If CanBe(k) Then
                If TheNextCell Is Nothing Then
                    m_Value = k
                    If Not m_box Is Nothing Then
                        m_box.Text = CStr(k)
                        m_box.Refresh
                    End If
                    AddSolution Solutions, nSolutions
                    If Not m_box Is Nothing Then
                        m_box.Text = ""
                        m_box.Refresh
                    End If
                    m_Value = 0
                    If bJust2 And (nSolutions > 1) Then Exit Sub
                Else
                    m_Value = k
                    If Not m_box Is Nothing Then
                        m_box.Text = CStr(k)
                        m_box.Refresh
                    End If
                    TheNextCell.Solve Solutions, nSolutions, bJust2
                    If Not m_box Is Nothing Then
                        m_box.Text = ""
                        m_box.Refresh
                    End If
                    m_Value = 0
                    If bJust2 And (nSolutions > 1) Then Exit Sub
                End If
            End If
        Next
    End If
End Sub

Public Property Get NextCell() As Cell
    If m_Col = 9 Then
        If m_Row = 9 Then
            Set NextCell = Nothing
        Else
            Set NextCell = m_Parent.Cell(m_Row + 1, 1)
        End If
    Else
        Set NextCell = m_Parent.Cell(m_Row, m_Col + 1)
    End If
End Property

Public Property Get Row() As Long
    Row = m_Row
End Property

Public Property Get Col() As Long
    Col = m_Col
End Property

Public Property Let Row(newRow As Long)
    m_Row = newRow
End Property

Public Property Let Col(newCol As Long)
    m_Col = newCol
End Property

Private Sub Class_Terminate()
    Dest
End Sub

Public Sub Dest()
    Set m_Parent = Nothing
    Set m_box = Nothing
End Sub

Sub AddSolution(Solutions() As Solution, nSolutions As Long)
    Dim Solution As Solution
    Dim i As Long
    Dim j As Long
    
    Set Solution = New Solution
    For i = 1 To 9
        For j = 1 To 9
            Solution.Values(i, j) = m_Parent.Cell(i, j).Value
        Next
    Next
    nSolutions = nSolutions + 1
    If nSolutions = 1 Then
        ReDim Solutions(1 To nSolutions)
    Else
        ReDim Preserve Solutions(1 To nSolutions)
    End If
    
    Set Solutions(nSolutions) = Solution
End Sub

Public Property Set Box(newBox As TextBox)
    Set m_box = newBox
End Property

Public Property Get Box() As TextBox
    Set Box = m_box
End Property

