VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Cells"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'    Sudoku Solver
'    Copyright (C) 2006  S. I. Becker
'
'    This program is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program; if not, write to the Free Software
'    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
'
'    If you want to contact the authour, write to 44 Merrion Close,
'    Royal Tunbridge Wells, TN4 9JJ, England, or e-mail stewart@sibecker.co.uk

Option Explicit

Private m_Cells(1 To 9, 1 To 9) As Cell

Public Property Get Cell(Row As Long, Col As Long) As Cell
    Set Cell = m_Cells(Row, Col)
End Property

Private Sub Class_Initialize()
    Init
End Sub

Public Sub Init()
    Dim i As Long
    Dim j As Long
    
    For i = 1 To 9
        For j = 1 To 9
            Set m_Cells(i, j) = New Cell
            Set m_Cells(i, j).Parent = Me
            m_Cells(i, j).Value = 0
            m_Cells(i, j).Row = i
            m_Cells(i, j).Col = j
        Next
    Next
End Sub

Public Sub Dest()
    Dim i As Long
    Dim j As Long
    
    For i = 1 To 9
        For j = 1 To 9
            If Not m_Cells(i, j) Is Nothing Then m_Cells(i, j).Dest
            Set m_Cells(i, j) = Nothing
        Next
    Next
End Sub

Private Sub Class_Terminate()
    Dest
End Sub

Public Sub Solve(CompleteSolutions() As Solution, nSolutions As Long, bJust2 As Boolean)
    Dim NoSolutionsYet() As Solution
    
    nSolutions = 0
    CompleteSolutions = NoSolutionsYet
    
    m_Cells(1, 1).Solve CompleteSolutions, nSolutions, bJust2
End Sub
